//West Islip High School - Engineering Technology
// Color Sensor - Motor Sketch

// defines pins numbers
int E1 = 5;  // Enable Pin for motor 1 (ENA on board)
int E2 = 6;  // Enable Pin for motor 2 (ENB on board)

int I1 = 2;  // Control pin 1 for motor 1
int I2 = 3;  // Control pin 2 for motor 1
int I3 = 4;  // Control pin 1 for motor 2
int I4 = 7;  // Control pin 2 for motor 2

// Define color sensor pins
#define S0 12
#define S1 11
#define S2 10
#define S3 9          
#define sensorOut 8

// Variables for Color Pulse Width Measurements
int redPW = 0;
int greenPW = 0;
int bluePW = 0;

void setup() {
  // Set S0 - S3 as outputs Color Sensor
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);

  // Set Pulse Width scaling to 20% - Color Sensor
  digitalWrite(S0,HIGH);
  digitalWrite(S1,LOW);

  // Set Sensor output as input - Color Sensor
  pinMode(sensorOut, INPUT);

  //Set-Up for Motor Pins
  pinMode(E1, OUTPUT);    //Control pin for Motor 1 set to OUTPUT
  pinMode(E2, OUTPUT);    //Control pin for Motor 2 set to OUTPUT

  pinMode(I1, OUTPUT);    //Voltage direction pin for Motor 1 set to OUTPUT    
  pinMode(I2, OUTPUT);    //Voltage direction pin for Motor 1 set to OUTPUT
  
  pinMode(I3, OUTPUT);    //Voltage direction pin for Motor 2 set to OUTPUT
  pinMode(I4, OUTPUT);    //Voltage direction pin for Motor 2 set to OUTPUT

  // Setup Serial Monitor
  Serial.begin(9600);
}

void loop() {
 //setsup motors
  analogWrite(E1, 250);  // Motor 1 get ready - high speed
  analogWrite(E2, 250); // Motor 2 get ready - high speed
  
  // Read Red Pulse Width
  redPW = getRedPW();
  // Delay to stabilize sensor
  delay(200);

  // Read Green Pulse Width
  greenPW = getGreenPW();
  // Delay to stabilize sensor
  delay(200);

  // Read Blue Pulse Width
  bluePW = getBluePW();
  // Delay to stabilize sensor
  delay(200);

  //Print output to Serial Monitor
  Serial.print("Red PW = ");
  Serial.print(redPW);
  Serial.print(" - Green PW = ");
  Serial.print(greenPW);
  Serial.print(" - Blue PW = ");
  Serial.println(bluePW);

  if(redPW > 95 && redPW < 110) // Evaluate Red Color
  {
    Serial.println("STOP");
   // Turn off one motor- backup with the other
    digitalWrite(I1, LOW);  //Motor 1 - polarity -
    digitalWrite(I2, LOW); //Motor 1 - polarity +
    
    digitalWrite(I3, LOW); //Motor 2 - polarity -
    digitalWrite(I4, LOW); //Motor 2 - polarity +

   delay(2000); 
   
  }
  else if (greenPW > 300 && greenPW < 370) // Evaluate Green Color 
  {
    Serial.println("TURN");
   // Turn off one motor- backup with the other
    digitalWrite(I1, LOW);  //Motor 1 - polarity -
    digitalWrite(I2, HIGH); //Motor 1 - polarity +
    
    digitalWrite(I3, HIGH); //Motor 2 - polarity -
    digitalWrite(I4, LOW); //Motor 2 - polarity +

   delay(2000); 
   
  }
  else if (bluePW > 110 && bluePW < 130) // Evaluate Blue Color 
  {
    Serial.println("Backup");
     // Turn off one motor- backup with the other
    digitalWrite(I1, LOW);  //Motor 1 - polarity -
    digitalWrite(I2, HIGH); //Motor 1 - polarity +
    
    digitalWrite(I3, LOW); //Motor 2 - polarity -
    digitalWrite(I4, HIGH); //Motor 2 - polarity +

   delay(2000); 
  }
  else{  // If no Color is identified go straight
    
  // go forward - both wheels rotate same direction
Serial.println("FORWARD");
    digitalWrite(I1, HIGH); //Motor 1 - polarity +
    digitalWrite(I2, LOW);  //Motor 1 - polarity -
    
    digitalWrite(I3, HIGH); //Motor 2 - polarity +
    digitalWrite(I4, LOW); //Motor 2 - pN,B,M,M,,,,,,,,,,,,M,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,N,N.W7W7www  olarity -

    //d  elay(500);
}    

}


// Function to read Red Pulse Widths
int getRedPW() {
  // Set sensor to read Red only
  digitalWrite(S2,LOW);
  digitalWrite(S3,LOW);
  // Define integer to represent Pulse Width
  int PW;
  // Read the output Pulse Width
  PW = pulseIn(sensorOut, LOW);
  // Return the value
  return PW;
}

// Function to read Green Pulse Widths
int getGreenPW() {
  // Set sensor to read Green only
  digitalWrite(S2,HIGH);
  digitalWrite(S3,HIGH);
  // Define integer to represent Pulse Width
  int PW;
  // Read the output Pulse Width
  PW = pulseIn(sensorOut, LOW);
  // Return the value
  return PW;
}

// Function to read Blue Pulse Widths
int getBluePW() {
  // Set sensor to read Blue only
  digitalWrite(S2,LOW);
  digitalWrite(S3,HIGH);
  // Define integer to represent Pulse Width
  int PW;
  // Read the output Pulse Width
  PW = pulseIn(sensorOut, LOW);
  // Return the value
  return PW;
}

 
